<?php
// $Id: vidi_gvscb.inc,v 1.1 2010/10/07 09:21:20 obojan Exp $

/**
 * @file
 * Google Visualizations ajax callbacks
 */


function vidi_returning_gvs() {
  global $user;
  global $base_url;
  $type1=$_REQUEST['type'];
  $settings="width:600,height:400";

  $basiccharts=array(0, 2, 3, 4, 5, 6);
  $is_stacked=array(2, 3, 4);
  $is3D=array(0, 2, 4);
  $linlog=array(2, 3, 4, 5, 6);

  if ($_REQUEST['title'] !="NULL" && in_array($type1, $basiccharts)) {
    $settings .= ", title:'" . $_REQUEST['title'] . "'";
  }
  if ($_REQUEST['legend'] !="NULL" && in_array($type1, $basiccharts)) {
    $settings .= ", legend:'" . $_REQUEST['legend'] . "'";
  }
  if ($_REQUEST['linlog'] !="NULL" && $_REQUEST['linlog'] =="log" && in_array($type1, $linlog)) {
    $settings .= ",'logScale': TRUE";
  }
  if ($_REQUEST['is3D'] !="NULL" && in_array($type1, $is3D)) {
    $settings .= ",is3D:" . $_REQUEST['is3D'];
  }
  if ($_REQUEST['is_stacked'] !="NULL" && in_array($type1, $is_stacked)) {
    $settings .= ",is_stacked:" . $_REQUEST['is_stacked'];
  }

  $colorspie[1]=array("'#2912dc'", "'#125edc'", "'#15b8e0'", "'#86d8ec'", "'#84d60c'", "'#b5e96a'", "'#81017c'", "'#a857bd'", "'#ee45dc'", "'#f192de'", "'#fe8100'", "'#fab726'", "'#ffe600'", "'#fcf688'");
  $colorspie[2]=array("'#1e3c5c'", "'#d6dce3'", "'#374655'", "'#97badb'", "'#355574'", "'#bbc6cf'", "'#53616e'", "'#4f6f8f'", "'#83a6c6'", "'#778490'", "'#9ca8b2'", "'#6c8eae'");
  $colorspie[3]=array("'#01701b'", "'#bef494'", "'#067c26'", "'#abee8e'", "'#0b8b32'", "'#91e585'", "'#129b40'", "'#74db7b'", "'#05b03d'", "'#28b759'", "'#57d070'", "'#57c32d'");
  $colorspie[4]=array("'#00aeef'", "'#dbf2fd'", "'#11a6f0'", "'#ccedfc'", "'#24aff2'", "'#b9e8fb'", "'#38b9f3'", "'#a5e2fa'", "'#4bc1f4'", "'#8cdaf8'", "'#61cbf5'");
  $colorspie[5]=array("'#653092'", "'#ebe0ef'", "'#73429d'", "'#ceb8e0'", "'#7b4ca4'", "'#c6addb'", "'#9168b5'", "'#b597d1'", "'#ae8dcc'", "'#ae8ecc'");
  $colorspie[6]=array("'#5b0606'", "'#969595'", "'#2c2324'", "'#e95b59'", "'#7a0b09'", "'#7c7475'", "'#3a2c2d'", "'#d13f3a'", "'#9a130e'", "'#49383a'", "'#5a4b4d'", "'#b7241f'");
  $colorspie[7]=array("'#e26002'", "'#e66c04'", "'#e66c04'", "'#ed8507'", "'#f2940c'", "'#f5a115'", "'#f7ae28'", "'#f8b63a'", "'#fac25a'", "'#fac970'", "'#fbd79c'", "'#fbd79c'");
  $colorspie[8]=array("'#0367a5'", "'#00b0d9'", "'#74b64a'", "'#bed63a'", "'#fe0000'", "'#e54044'", "'#6067f3'", "'#764fe8'", "'#f2055d'", "'#f15ea4'", "'#f4a910'", "'#f8da0a'");
  $colorspie[9]=array("'#1d73aa'", "'#c44441'", "'#8cbc4f'", "'#7a5892'", "'#009ab2'", "'#f48533'", "'#8baad1'");
  $colorspie[10]=array("'#003DF5'", "'#6633FF'", "'#CC33FF'", "'#FF33CC'", "'#3366FF'", "'#33CCFF'", "'#C3D9FF'", "'#002EB8'", "'#FF3366'", "'#33FFCC'", "'#B88A00'", "'#F5B800'", "'#FF6633'", "'#33FF66'", "'#66FF33'", "'#CCFF33'", "'#FFCC33'");
  $colorspie[11]=array("'#FFD300'", "'#90FF00'", "'#FF5F00'", "'#3D00FF'", "'#807540'", "'#648040'", "'#805740'", "'#4F4080'", "'#4D3F00'", "'#2B4D00'", "'#4D1C00'", "'#12004D'", "'#FFE980'", "'#C8FF80'", "'#FFAF80'", "'#9E80FF'", "'#FFFBE6'", "'#F4FFE6'", "'#FFEFE6'", "'#ECE6FF'");
  $colorspie[12]=array("'#FF1A00'", "'#CC0000'", "'#FF7400'", "'#008C00'", "'#006E2E'", "'#4096EE'", "'#FF0084'");
  $colorspie[13]=array("'#B02B2C'", "'#D15600'", "'#C79810'", "'#73880A'", "'#6BBA70'", "'#3F4C6B'", "'#356AA0'", "'#D01F3C'");
  $colorspie[14]=array("'#d81f26'", "'#f15d51'", "'#f7a396'", "'#fde2db'", "'#dde9ec'", "'#88cadd'", "'#0092c2'", "'#144a90'");
  $colorspie[15]=array("'#ebebff'", "'#000379'");
  $colorspie[16]=array("'#ffeef3'", "'#8f0028'");
  $colorspie[17]=array("'#fce5ff'", "'#b100c6'");
  $colorspie[18]=array("'#e3ffc7'", "'#3d7c00'");
  $colorspie[19]=array("'#a12c21'", "'#e74d24'", "'#f37121'", "'#f6f5bc'", "'#f7f9e4'", "'#f89728'", "'#fec246'", "'#ffe38d'");
  $colorspie[20]=array("'#00fa2c'", "'#00dd25'", "'#00bf1f'", "'#00a06a'", "'#007d10'", "'#005908'", "'002e02'", "'#000d10'");

  $colorsmap[1]=array(0x2912dc, 0x125edc, 0x15b8e0, 0x86d8ec, 0x84d60c, 0xb5e96a, 0x81017c, 0xa857bd, 0xee45dc, 0xf192de, 0xfe8100, 0xfab726, 0xffe600, 0xfcf688);
  $colorsmap[2]=array(0x1e3c5c, 0x374655, 0x355574, 0x53616e, 0x4f6f8f, 0x778490, 0x6c8eae, 0x9ca8b2, 0x83a6c6, 0xbbc6cf, 0x97badb, 0xd6dce3);
  $colorsmap[3]=array(0xc1f596, 0x006e1a);
  $colorsmap[4]=array(0xe0f3fd, 0x00aeef);
  $colorsmap[5]=array(0xece2f0, 0x653092);
  $colorsmap[6]=array(0x5b0606, 0x2c2324, 0x7a0b09, 0x3a2c2d, 0x9a130e, 0x49383a, 0xb7241f, 0x5a4b4d, 0xd13f3a, 0x7c7475, 0xe95b59, 0x969595);
  $colorsmap[7]=array(0xfbd79c, 0xe26002);
  $colorsmap[8]=array(0x0367a5, 0x00b0d9, 0x74b64a, 0xbed63a, 0xfe0000, 0xe54044, 0x6067f3, 0x764fe8, 0xf2055d, 0xf15ea4, 0xf4a910, 0xf8da0a);
  $colorsmap[9]=array(0x1d73aa, 0xc44441, 0x8cbc4f, 0x7a5892, 0x009ab2, 0xf48533, 0x8baad1);
  $colorsmap[10]=array(0x3366FF, 0x6633FF, 0xCC33FF, 0xFF33CC, 0x33CCFF, 0xC3D9FF, 0x003DF5, 0x002EB8, 0xFF3366, 0x33FFCC, 0xB88A00, 0xF5B800, 0xFF6633, 0x33FF66, 0x66FF33, 0xCCFF33, 0xFFCC33);
  $colorsmap[11]=array(0xFFD300, 0x90FF00, 0xFF5F00, 0x3D00FF, 0x807540, 0x648040, 0x805740, 0x4F4080, 0x4D3F00, 0x2B4D00, 0x4D1C00, 0x12004D, 0xFFE980, 0xC8FF80, 0xFFAF80, 0x9E80FF, 0xFFFBE6, 0xF4FFE6, 0xFFEFE6, 0xECE6FF);
  $colorsmap[12]=array(0xFF1A00, 0xCC0000, 0xFF7400, 0x008C00, 0x006E2E, 0x4096EE, 0xFF0084);
  $colorsmap[13]=array(0xB02B2C, 0xD15600, 0xC79810, 0x73880A, 0x6BBA70, 0x3F4C6B, 0x356AA0, 0xD01F3C);
  $colorsmap[14]=array(0xd81f26, 0xf15d51, 0xf7a396, 0xfde2db, 0xdde9ec, 0x88cadd, 0x0092c2, 0x144a90);
  $colorsmap[15]=array(0xebebff, 0x000379);
  $colorsmap[16]=array(0xffeef3, 0x8f0028);
  $colorsmap[17]=array(0xfce5ff, 0xb100c6);
  $colorsmap[18]=array(0xe3ffc7, 0x3d7c00);
  $colorsmap[19]=array(0xa12c21, 0xffe38d);
  $colorsmap[20]=array(0x00fa2c, 0x000d10);

  $settingsmapcolors='';
  if ($_REQUEST['color']!='0' && $type1!=9 && $type1!=7) {
    $setting .= ",'colors':[" . implode(', ', $colorspie[$_REQUEST['color']]) . "]";
  }
    

  if (isset($_REQUEST['table'])) {
    $tablename=$_REQUEST['table'];
    $no_of_rows = db_result(db_query("SELECT count(*) FROM " . $tablename));
    if ($type1!='9' && $type1!='10') {
      $sql="SELECT * FROM " . $tablename;
    }
    else {
      $sql="SELECT * FROM " . $tablename;
      if (isset($_REQUEST['yaxis11'])) {
        if ($_REQUEST['yaxis11']!='NULL') {
          $sql="SELECT * FROM {" . $tablename . "} ORDER BY " . $_REQUEST['yaxis11'] . " ASC";
        }
      }
    }
    $results = db_query($sql);
  }
  else {
    return;
  }
  switch ($type1) {
    case 0:
      $strdata="";
      $type="PieChart";
      $strdata="";
      $xaxis=$_REQUEST['xaxis'];
      $yaxis1=$_REQUEST['yaxis1'];
      if ($xaxis !="NULL" && $yaxis1 !="NULL") {
        $strdata = "var data = new google.visualization.DataTable();";
        $strdata .= "data.addColumn('string', '" . $xaxis . "');data.addColumn('number', '" . $yaxis1 . "');data.addRows(" . $no_of_rows . ");";
        if ($xaxis!='NULL' && $yaxis1!='NULL') {
          $j=0;
          while ($result = db_fetch_array($results)) {
            $xvalue=$result[$xaxis];
            $yvalue=$result[$yaxis1];
            $strdata .= "data.setValue(" . $j . ", 0, " . (is_null($xvalue)?'undefined':"'" .  str_replace("'", "\'", $xvalue) . "'") . ");";
            $strdata .= "data.setValue(" . $j . ", 1, " . (is_null($yvalue)?'undefined':$yvalue) . ");";
            $j++;
          }
        }
        $strdata .= "var chart = new google.visualization." . $type . "(document.getElementById('chart_div'));chart.draw(data, {" . $settings . "});";
      }
      else {
        $strdata="var data = new google.visualization.DataTable();data.addColumn('string', 'Task');data.addColumn('number', 'Hours per Day');data.addRows(5);
              data.setValue(0, 0, 'Work');
              data.setValue(0, 1, 11);
              data.setValue(1, 0, 'Eat');
              data.setValue(1, 1, 2);
              data.setValue(2, 0, 'Commute');
              data.setValue(2, 1, 2);
              data.setValue(3, 0, 'Watch TV');
              data.setValue(3, 1, 2);
              data.setValue(4, 0, 'Sleep');
              data.setValue(4, 1, 7);
              var chart = new google.visualization.PieChart(document.getElementById('chart_div'));
              chart.draw(data, {" . $settings . "});
        ";
      }
      break;
    case 1:
      $type="Gauge";
      $strdata="";
      $xaxis=$_REQUEST['xaxis'];
      $yaxis1=$_REQUEST['yaxis1'];
      if ($xaxis !="NULL" && $yaxis1 !="NULL") {
        $strdata = "var data = new google.visualization.DataTable();";
        $strdat .= "data.addColumn('string', '" . $xaxis . "');data.addColumn('number', '" . $yaxis1 . "');data.addRows(" . $no_of_rows . ");";
        $j=0;
        while ($result = db_fetch_array($results)) {
          $xvalue=$result[$xaxis];
          $yvalue=$result[$yaxis1];
          $strdata .= "data.setValue(" . $j . ", 0, " . (is_null($xvalue)?'undefined':"'" .  str_replace("'", "\'", $xvalue) . "'") . ");";
          $strdata .= "data.setValue(" . $j . ", 1, " . (is_null($yvalue)?'undefined':$yvalue) . ");";
          $j++;
        }
        $strdata .= "var chart = new google.visualization." . $type . "(document.getElementById('chart_div'));chart.draw(data, {" . $settings . "});";
      }
      else {
        $strdata="var data = new google.visualization.DataTable();
            data.addColumn('string', 'Label');
            data.addColumn('number', 'Value');
            data.addRows(3);
            data.setValue(0, 0, 'Memory');
            data.setValue(0, 1, 80);
            data.setValue(1, 0, 'CPU');
            data.setValue(1, 1, 55);
            data.setValue(2, 0, 'Network');
            data.setValue(2, 1, 68);
            var chart = new google.visualization.Gauge(document.getElementById('chart_div'));
            chart.draw(data, {" . $settings . "});";
      }
      break;
    case 2:
      $type="BarChart";
      $xaxis=$_REQUEST['xaxis'];
      $yaxis1=$_REQUEST['yaxis1'];
      if ($xaxis !="NULL" && $yaxis1 !="NULL") {
        $strdata = "var data = new google.visualization.DataTable();";
        $strdat .= "data.addColumn('string', '" . $xaxis . "');";
        for ($jj=1; $jj<6; $jj++) {
          if ($_REQUEST['yaxis' . $jj] != 'NULL') {
            $strdata .= "data.addColumn('number', '" . $_REQUEST['yaxis' . $jj] . "');";
          }
        }
        $strdata .= "data.addRows(" . $no_of_rows . ");";
        $j=0;
        while ($result = db_fetch_array($results)) {
          $jjj=1;
          $xvalue=$result[$xaxis];
          $strdata .= "data.setValue(" . $j . ", 0, " . ( is_null($xvalue) ? 'undefined' : "'" .  str_replace("'", "\'", $xvalue) . "'" ) . ");";
          for ($jj=1;$jj<6;$jj++) {
            if ($_REQUEST['yaxis' . $jj] != 'NULL' ) {
              $yvalue=$result[$_REQUEST['yaxis' . $jj]];
              $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
              $jjj++;
            }
          }
          $j++;
        }
        $strdata .= "var chart = new google.visualization." . $type . "(document.getElementById('chart_div'));chart.draw(data, {" . $settings . "});";
      }
      else {
        $strdata="var data = new google.visualization.DataTable();
          data.addColumn('string', 'Year');
          data.addColumn('number', 'Sales');
          data.addColumn('number', 'Expenses');
          data.addRows(4);
          data.setValue(0, 0, '2004');
          data.setValue(0, 1, 1000);
          data.setValue(0, 2, 400);
          data.setValue(1, 0, '2005');
          data.setValue(1, 1, 1170);
          data.setValue(1, 2, 460);
          data.setValue(2, 0, '2006');
          data.setValue(2, 1, 660);
          data.setValue(2, 2, 1120);
          data.setValue(3, 0, '2007');
          data.setValue(3, 1, 1030);
          data.setValue(3, 2, 540);
          var chart = new google.visualization.BarChart(document.getElementById('chart_div'));
          chart.draw(data, {" . $settings . "});";
      }
      break;
    case 3:
      $type="AreaChart";
      $xaxis=$_REQUEST['xaxis'];
      $yaxis1=$_REQUEST['yaxis1'];
      if ($xaxis !="NULL" && $yaxis1 !="NULL") {
        $strdata = "var data = new google.visualization.DataTable();";
        $strdat .= "data.addColumn('string', '" . $xaxis . "');";
        for ($jj=1; $jj<6; $jj++) {
          if ($_REQUEST['yaxis' . $jj] != 'NULL') {
            $strdata .= "data.addColumn('number', '" . $_REQUEST['yaxis' . $jj] . "');";
          }
        }
        $strdata .= "data.addRows(" . $no_of_rows . ");";
        $j=0;
        while ($result = db_fetch_array($results)) {
          $jjj=1;
          $xvalue=$result[$xaxis];
          $strdata .= "data.setValue(" . $j . ", 0, " . ( is_null($xvalue) ? 'undefined' : "'" .  str_replace("'", "\'", $xvalue) . "'" ) . ");";
          for ($jj=1;$jj<6;$jj++) {
            if ($_REQUEST['yaxis' . $jj] != 'NULL' ) {
              $yvalue=$result[$_REQUEST['yaxis' . $jj]];
              $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
              $jjj++;
            }
          }
          $j++;
        }
        $strdata .= "var chart = new google.visualization." . $type . "(document.getElementById('chart_div'));chart.draw(data, {" . $settings . "});";
      }
      else {
        $strdata="var data = new google.visualization.DataTable();
            data.addColumn('string', 'Year');
            data.addColumn('number', 'Sales');
            data.addColumn('number', 'Expenses');
            data.addRows([
            ['2004', 1000, 400],
            ['2005', 1170, 460],
            ['2006', 660, 1120],
            ['2007', 1030, 540]
            ]);
            var chart = new google.visualization.AreaChart(document.getElementById('chart_div'));
            chart.draw(data, {" . $settings . "});";
      }
      break;
    case 4:
      $type="ColumnChart";
      $xaxis=$_REQUEST['xaxis'];
      $yaxis1=$_REQUEST['yaxis1'];
      if ($xaxis !="NULL" && $yaxis1 !="NULL") {
        $strdata = "var data = new google.visualization.DataTable();";
        $strdat .= "data.addColumn('string', '" . $xaxis . "');";
        for ($jj=1; $jj<6; $jj++) {
          if ($_REQUEST['yaxis' . $jj] != 'NULL') {
            $strdata .= "data.addColumn('number', '" . $_REQUEST['yaxis' . $jj] . "');";
          }
        }
        $strdata .= "data.addRows(" . $no_of_rows . ");";
        $j=0;
        while ($result = db_fetch_array($results)) {
          $jjj=1;
          $xvalue=$result[$xaxis];
          $strdata .= "data.setValue(" . $j . ", 0, " . ( is_null($xvalue) ? 'undefined' : "'" .  str_replace("'", "\'", $xvalue) . "'" ) . ");";
          for ($jj=1;$jj<6;$jj++) {
            if ($_REQUEST['yaxis' . $jj] != 'NULL' ) {
              $yvalue=$result[$_REQUEST['yaxis' . $jj]];
              $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
              $jjj++;
            }
          }
          $j++;
        }
        $strdata .= "var chart = new google.visualization." . $type . "(document.getElementById('chart_div'));chart.draw(data, {" . $settings . "});";
      }
      else {
        $strdata="var data = new google.visualization.DataTable();
            data.addColumn('string', 'Year');
            data.addColumn('number', 'Sales');
            data.addColumn('number', 'Expenses');
            data.addRows(4);
            data.setValue(0, 0, '2004');
            data.setValue(0, 1, 1000);
            data.setValue(0, 2, 400);
            data.setValue(1, 0, '2005');
            data.setValue(1, 1, 1170);
            data.setValue(1, 2, 460);
            data.setValue(2, 0, '2006');
            data.setValue(2, 1, 660);
            data.setValue(2, 2, 1120);
            data.setValue(3, 0, '2007');
            data.setValue(3, 1, 1030);
            data.setValue(3, 2, 540);
            var chart = new google.visualization.ColumnChart(document.getElementById('chart_div'));
            chart.draw(data, {" . $settings . "});";
      }
      break;
    case 5:
      $type="LineChart";
      $xaxis=$_REQUEST['xaxis'];
      $yaxis1=$_REQUEST['yaxis1'];
      if ($xaxis !="NULL" && $yaxis1 !="NULL") {
        $strdata = "var data = new google.visualization.DataTable();";
        $strdat .= "data.addColumn('string', '" . $xaxis . "');";
        for ($jj=1; $jj<6; $jj++) {
          if ($_REQUEST['yaxis' . $jj] != 'NULL') {
            $strdata .= "data.addColumn('number', '" . $_REQUEST['yaxis' . $jj] . "');";
          }
        }
        $strdata .= "data.addRows(" . $no_of_rows . ");";
        $j=0;
        while ($result = db_fetch_array($results)) {
          $jjj=1;
          $xvalue=$result[$xaxis];
          $strdata .= "data.setValue(" . $j . ", 0, " . ( is_null($xvalue) ? 'undefined' : "'" .  str_replace("'", "\'", $xvalue) . "'" ) . ");";
          for ($jj=1;$jj<6;$jj++) {
            if ($_REQUEST['yaxis' . $jj] != 'NULL' ) {
              $yvalue=$result[$_REQUEST['yaxis' . $jj]];
              $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
              $jjj++;
            }
          }
          $j++;
        }
        $strdata .= "var chart = new google.visualization." . $type . "(document.getElementById('chart_div'));chart.draw(data, {" . $settings . "});";
      }
      else {
        $strdata="var data = new google.visualization.DataTable();
          data.addColumn('string', 'Year');
          data.addColumn('number', 'Sales');
          data.addColumn('number', 'Expenses');
          data.addRows(4);
          data.setValue(0, 0, '2004');
          data.setValue(0, 1, 1000);
          data.setValue(0, 2, 400);
          data.setValue(1, 0, '2005');
          data.setValue(1, 1, 1170);
          data.setValue(1, 2, 460);
          data.setValue(2, 0, '2006');
          data.setValue(2, 1, 860);
          data.setValue(2, 2, 580);
          data.setValue(3, 0, '2007');
          data.setValue(3, 1, 1030);
          data.setValue(3, 2, 540);
          var chart = new google.visualization.LineChart(document.getElementById('chart_div'));
          chart.draw(data, {" . $settings . "});";
        $strdata="";
      }
      break;
    case 6:
      $type="ScatterChart";
      $xaxis=$_REQUEST['xaxis1'];
      $yaxis1=$_REQUEST['yaxis1'];
      if ($xaxis !="NULL" && $yaxis1 !="NULL") {
        $strdata = "var data = new google.visualization.DataTable();";
        $strdata .= "data.addColumn('number', '" . $xaxis . "');";
        for ($jj=1; $jj<6; $jj++) {
          if ($_REQUEST['yaxis' . $jj] != 'NULL') {
            $strdata .= "data.addColumn('number', '" . $_REQUEST['yaxis' . $jj] . "');";
          }
        }
        $strdata .= "data.addRows(" . $no_of_rows . ");";
        $j=0;
        while ($result = db_fetch_array($results)) {
          $jjj=1;
          $xvalue=$result[$xaxis];
          $strdata .= "data.setValue(" . $j . ", 0," . (is_null($xvalue)?'undefined':$xvalue) . ");";
          for ($jj=1;$jj<6;$jj++) {
            if ($_REQUEST['yaxis' . $jj] != 'NULL' ) {
              $yvalue=$result[$_REQUEST['yaxis' . $jj]];
              $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
              $jjj++;
            }
          }
          $j++;
        }
        $strdata .= "var chart = new google.visualization." . $type . "(document.getElementById('chart_div'));chart.draw(data, {" . $settings . "});";
      }
      else {
        $strdata="var data = new google.visualization.DataTable();
              data.addColumn('number', 'Age');
              data.addColumn('number', 'Weight');
              data.addRows(6);
              data.setValue(0, 0, 8);
              data.setValue(0, 1, 12);
              data.setValue(1, 0, 4);
              data.setValue(1, 1, 5.5);
              data.setValue(2, 0, 11);
              data.setValue(2, 1, 14);
              data.setValue(3, 0, 4);
              data.setValue(3, 1, 4.5);
              data.setValue(4, 0, 3);
              data.setValue(4, 1, 3.5);
              data.setValue(5, 0, 6.5);
              data.setValue(5, 1, 7);
              var chart = new google.visualization.ScatterChart(document.getElementById('chart_div'));
              chart.draw(data, {" . $settings . "});";
      }
      break;
    case 7:
      $type="GeoMap";
      $no_of_cols=array();
      $strdata = "var data = new google.visualization.DataTable();";
      if ($_REQUEST['geomaptype']=='region') {
        $strdata .= "data.addColumn('string', '" . $_REQUEST['geomapstring'] . "');";
        $no_of_cols[]='geomapstring';
        if ($_REQUEST['yaxis1'] != 'NULL' ) {
          $strdata .= "data.addColumn('number', '" . $_REQUEST['yaxis1'] . "');";
          $no_of_cols[]='yaxis1';
        }
        if ($_REQUEST['xaxis'] != 'NULL' ) {
          $strdata .= "data.addColumn('string', '" . $_REQUEST['xaxis'] . "');";
          $no_of_cols[]='xaxis';
        }
      }
      else {
        if ($_REQUEST['geomaplat']!='NULL' && $_REQUEST['geomaplon']!='NULL') {
          $strdata .= "data.addColumn('number', '" . $_REQUEST['geomaplat'] . "');";
          $no_of_cols[]='geomaplat';
          $strdata .= "data.addColumn('number', '" . $_REQUEST['geomaplon'] . "');";
          $no_of_cols[]='geomaplon';
          if ($_REQUEST['yaxis1']!='NULL') {
            $strdata .= "data.addColumn('number', '" . $_REQUEST['yaxis1'] . "');";
            $no_of_cols[]='yaxis1';
          }
          if ($_REQUEST['xaxis']!='NULL') {
            $strdata .= "data.addColumn('string', '" . $_REQUEST['xaxis'] . "');";
            $no_of_cols[]='xaxis';
          }
        }
        else {
          if ($_REQUEST['geomapstring']!='NULL') {
            $strdata .= "data.addColumn('string', '" . $_REQUEST['geomapstring'] . "');";
            $no_of_cols[]='geomapstring';
            if ($_REQUEST['yaxis1']!='NULL') {
              $strdata .= "data.addColumn('number', '" . $_REQUEST['yaxis1'] . "');";
              $no_of_cols[]='yaxis1';
            }
            if ($_REQUEST['xaxis']!='NULL') {
              $strdata .= "data.addColumn('string', '" . $_REQUEST['xaxis'] . "');";
              $no_of_cols[]='xaxis';
            }
          }
          else
            $strdata="";
        }
      }
      if ($strdata!="") {
        $strdata .= "data.addRows(" . $no_of_rows . ");";
        $j=0;
        while ($result = db_fetch_array($results)) {
          for ($jj=0;$jj<count($no_of_cols);$jj++) {
            $xvalue=$result[$_REQUEST[$no_of_cols[$jj]]];
            if ($no_of_cols[$jj]=='yaxis1' || $no_of_cols[$jj]=='geomaplat' || $no_of_cols[$jj]=='geomaplon') {
              $strdata .= "data.setValue(" . $j . ", " . $jj . ", " . (is_null($xvalue)?'undefined':$xvalue) . ");";
            }
            else {
              if ($no_of_cols[$jj]=='xaxis') {
                $xvalue=strtoupper($xvalue);
              }
              $strdata .= "data.setValue(" . $j . ", " . $jj . ", " . (is_null($xvalue)?'undefined':"'" .  str_replace("'", "\'", $xvalue) . "'") . ");";
            }
          }
          $j++;
        }
        if ($_REQUEST['color'] != '0') {
          $strdata .= "var chart = new google.visualization." . $type . "(document.getElementById('chart_div'));chart.draw(data, {region:'" . $_REQUEST['region1'] . "',dataMode:'" . $_REQUEST['geomaptype'] . "', 'colors':[" . implode(', ', $colorsmap[$_REQUEST['color']]) . "]});";
        }
        else {
          $strdata .= "var chart = new google.visualization." . $type . "(document.getElementById('chart_div'));chart.draw(data, {region:'" . $_REQUEST['region1'] . "',dataMode:'" . $_REQUEST['geomaptype'] . "'});";
        }
      }
      else {
        if ($_REQUEST['color'] != '0') $setting .= ",'colors':[" . implode(', ', $colorsmap[$_REQUEST['color']]) . "]";
        $strdata="var data = new google.visualization.DataTable();data.addRows(6);data.addColumn('string', 'Country');
            data.addColumn('number', 'Popularity');data.setValue(0, 0, 'Germany');data.setValue(0, 1, 200);data.setValue(1, 0, 'United States');
            data.setValue(1, 1, 300);data.setValue(2, 0, 'Brazil');data.setValue(2, 1, 400);data.setValue(3, 0, 'Canada');data.setValue(3, 1, 500);
            data.setValue(4, 0, 'France');data.setValue(4, 1, 600);data.setValue(5, 0, 'RU');data.setValue(5, 1, 700);
            var chart = new google.visualization.GeoMap(document.getElementById('chart_div'));
            chart.draw(data, {" . $settings . "});";
      }
      break;
    case 8:
      $type="IntensityMap";
      $xaxis=$_REQUEST['xaxis'];
      $yaxis1=$_REQUEST['yaxis1'];
      if ($xaxis !="NULL" && $yaxis1 !="NULL") {
        $strdata = "var data = new google.visualization.DataTable();";
        $strdata .= "data.addColumn('string', '" . $xaxis . "');";
        for ($jj=1; $jj<6; $jj++) {
          if ($_REQUEST['yaxis' . $jj] != 'NULL') {
            $strdata .= "data.addColumn('number', '" . $_REQUEST['yaxis' . $jj] . "');";
          }
        }
        $strdata .= "data.addRows(" . $no_of_rows . ");";
        $j=0;
        while ($result = db_fetch_array($results)) {
          $jjj=1;
          $xvalue=$result[$xaxis];
          $strdata .= "data.setValue(" . $j . ", 0, " . ( is_null($xvalue) ? 'undefined' : "'" .  str_replace("'", "\'", $xvalue) . "'" ) . ");";
          for ($jj=1;$jj<6;$jj++) {
            if ($_REQUEST['yaxis' . $jj] != 'NULL' ) {
              $yvalue=$result[$_REQUEST['yaxis' . $jj]];
              $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
              $jjj++;
            }
          }
          $j++;
        }
        if ($_REQUEST['region']!='NULL') {
          $setting .= ",region:'" . $_REQUEST['region'] . "'";
        }
        $strdata .= "var chart = new google.visualization." . $type . "(document.getElementById('chart_div'));chart.draw(data, {" . $settings . "});";
      }
      else {
        $strdata="var data = new google.visualization.DataTable();
        data.addColumn('string', '', 'Country');
        data.addColumn('number', 'Population (mil)', 'a');
        data.addColumn('number', 'Area (km2)', 'b');
        data.addRows(5);
        data.setValue(0, 0, 'CN');
        data.setValue(0, 1, 1324);
        data.setValue(0, 2, 9640821);
        data.setValue(1, 0, 'IN');
        data.setValue(1, 1, 1133);
        data.setValue(1, 2, 3287263);
        data.setValue(2, 0, 'US');
        data.setValue(2, 1, 304);
        data.setValue(2, 2, 9629091);
        data.setValue(3, 0, 'ID');
        data.setValue(3, 1, 232);
        data.setValue(3, 2, 1904569);
        data.setValue(4, 0, 'BR');
        data.setValue(4, 1, 187);
        data.setValue(4, 2, 8514877);
        var chart = new google.visualization.IntensityMap(document.getElementById('chart_div'));
        chart.draw(data, {" . $settings . "});";
      }
      break;
    case 9:
      $type="MotionChart";
      $strdata="";
      if ($_REQUEST['xaxis']!="NULL" && $_REQUEST['yaxis11']!="NULL" && $_REQUEST['yaxis2']!="NULL") {
        $strdata = "var data = new google.visualization.DataTable();";
        $xaxis=$_REQUEST['xaxis'];
        $strdata .= "data.addColumn('string', '" . $xaxis . "');";
        $yaxis11=$_REQUEST['yaxis11'];
        if ($_REQUEST['mcdateformat']=='1') {
          $strdata .= "data.addColumn('date', '" . $yaxis11 . "');";
        }
        elseif ($_REQUEST['mcdateformat']=='2') {
          $strdata .= "data.addColumn('number', '" . $yaxis11 . "');";
        }
        else {
          $strdata .= "data.addColumn('string', '" . $yaxis11 . "');";
        }
        for ($jj=2; $jj<6; $jj++) {
          if ($_REQUEST['yaxis' . $jj] != 'NULL') {
            $strdata .= "data.addColumn('number', '" . $_REQUEST['yaxis' . $jj] . "');";
          }
        }
        for ($jj=2; $jj<6; $jj++) {
          if ($_REQUEST['zaxis' . $jj] != 'NULL') {
            $strdata .= "data.addColumn('string', '" . $_REQUEST['zaxis' . $jj] . "');";
          }
        }
        $strdat .= "data.addRows(" . $no_of_rows . ");";
        $j=0;
        while ($result = db_fetch_array($results)) {
          $strdata .= "data.setValue(" . $j . ", 0," . (is_null($result[$xaxis])?'undefined':"'" .  str_replace("'", "\'", $result[$xaxis]) . "'") . ");";

          if (is_null($result[$yaxis11])) {
            $strdata .= "data.setValue(" . $j . ", 1, undefined);";
          }
          else {
            switch ($_REQUEST['mcdateformat']) {
              case '1':
                $yvaluedate = strtotime($result[$yaxis11]);
                if ($yvaluedate === FALSE) {
                  $strdata .= "data.setValue(" . $j . ", 1, undefined);";
                }
                else {
                  $strdata .= "data.setValue(" . $j . ", 1, new Date (" . date('Y', $yvaluedate) . ", " . (date('m', $yvaluedate)-1) . ", " . date('d', $yvaluedate) . "));";
                }
                break;
              case '2':
                $yvaluedate = strtotime($result[$yaxis11]);
                if ($yvaluedate === FALSE) {
                  $strdata .= "data.setValue(" . $j . ", 1, undefined);";
                }
                else {
                  $strdata .= "data.setValue(" . $j . ", 1,". date('Y', $yvaluedate) .");";
                }
                break;
              case '3':
                $yvaluedate = strtotime($result[$yaxis11]);
                if ($yvaluedate === FALSE) {
                  $strdata .= "data.setValue(" . $j . ", 1, undefined);";
                }
                else {
                  $strdata .= "data.setValue(" . $j . ", 1,'" . date('Y', $yvaluedate) . "W" . date('W', $yvaluedate) . "');";
                }
                break;
              case '4':
                if (preg_match("/^(\d{4})Q(\d{1})$/", $result[$yaxis11], $aaa)) {
                  $yvaluedate = strtotime($aaa[1] . "W" . ($aaa[2]-1)*15+1);
                  $strdata .= "data.setValue(" . $j . ", 1,'". date('Y', $yvaluedate) . "Q" . ((int)floor(date('m', $yvaluedate)/3.1)+1) . "');";
                }
                else {
                  $yvaluedate = strtotime($result[$yaxis11]);
                  if ($yvaluedate === FALSE) {
                    $strdata .= "data.setValue(" . $j . ", 1, undefined);";
                  }
                  else {
                    $strdata .= "data.setValue(" . $j . ", 1,'" . date('Y', $yvaluedate) . "Q" . ((int)floor(date('m', $yvaluedate)/3.1)+1) . "');";
                  }
                }
                break;
            }
          }
          $jjj=2;
          for ($jj=2; $jj<6; $jj++) {
            if ($_REQUEST['yaxis' . $jj] != 'NULL') {
              $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($result[$_REQUEST['yaxis' . $jj]])?'undefined':$result[$_REQUEST['yaxis' . $jj]]) . ");";
              $jjj++;
            }
          }
          for ($jj=2;$jj<6;$jj++) {
            if ($_REQUEST['zaxis' . $jj] != 'NULL') {
              $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($result[$_REQUEST['zaxis' . $jj]])?'undefined':"'" .  str_replace("'", "\'", $result[$_REQUEST['zaxis' . $jj]]) . "'") . ");";
              $jjj++;
            }
          }
          $j++;
        }
        $strdata .= "var chart = new google.visualization." . $type . "(document.getElementById('chart_div'));chart.draw(data, {" . $settings . "});";
      }
      else {
        $strdata="var data = new google.visualization.DataTable();
        data.addColumn('string', 'Fruit');
        data.addColumn('date', 'Date');
        data.addColumn('number', 'Sales');
        data.addColumn('number', 'Expenses');
        data.addColumn('string', 'Location');
        data.addRows([
        ['Apples',new Date (1988, 0,1),1000,300,'East'],
        ['Oranges',new Date (1988, 0,1),1150,200,'West'],
        ['Bananas',new Date (1988, 0,1),300,250,'West'],
        ['Apples',new Date (1989,6,1),1200,400,'East'],
        ['Oranges',new Date (1989,6,1),750,150,'West'],
        ['Bananas',new Date (1989,6,1),788,617,'West']
        ]);
        var chart = new google.visualization.MotionChart(document.getElementById('chart_div'));
        chart.draw(data, {" . $settings . "});";
      }
      break;
    case 10:
      $type="AnnotatedTimeLine";
      $strdata="";
      $yaxis11=$_REQUEST['yaxis11'];
      if ($yaxis11!="NULL" && $_REQUEST['yaxis1']!="NULL") {
        $strdata = "var data = new google.visualization.DataTable();";
        $strdat .= "data.addColumn('date', '" . $yaxis11. "');";
        for ($jj=1;$jj<6;$jj++) {
          if ($_REQUEST['yaxis' . $jj] != 'NULL') {
            $strdata .= "data.addColumn('number', '" . $_REQUEST['yaxis' . $jj] . "');";
          }
          if ($_REQUEST['zaxis' . $jj] != 'NULL') {
            $strdata .= "data.addColumn('string', '" . $_REQUEST['zaxis' . $jj] . "');";
          }
          if ($_REQUEST['zzaxis' . $jj] != 'NULL') {
            $strdata .= "data.addColumn('string', '" . $_REQUEST['zzaxis' . $jj] . "');";
          }
        }
        $strdata .= "data.addRows(" . $no_of_rows . ");";
        $j=0;
        while ($result = db_fetch_array($results)) {
          if (is_null($result[$yaxis11])) {
            $strdata .= "data.setValue(" . $j . ", 0, undefined);";
          }
          else {
            $yvaluedate = strtotime($result[$yaxis11]);
            if ($yvaluedate === FALSE) {
              $strdata .= "data.setValue(" . $j . ", 0, undefined);";
            }
            else {
              $strdata .= "data.setValue(" . $j . ", 0, new Date (" . date('Y', $yvaluedate) . ", " . (date('m', $yvaluedate)-1) . ", " . date('d', $yvaluedate) . "));";
            }
          }
          $jjj=1;
          for ($jj=1;$jj<6;$jj++) {
            if ($_REQUEST['yaxis' . $jj] != 'NULL') {
              $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($result[$_REQUEST['yaxis' . $jj]])?'undefined':$result[$_REQUEST['yaxis' . $jj]]) . ");";
              $jjj++;
            }
            if ($_REQUEST['zaxis' . $jj] != 'NULL') {
              $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($result[$_REQUEST['zaxis' . $jj]])?'undefined':"'" .  str_replace("'", "\'", $result[$_REQUEST['zaxis' . $jj]]) . "'") . ");";
              $jjj++;
            }
            if ($_REQUEST['zzaxis' . $jj] != 'NULL') {
              $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($result[$_REQUEST['zzaxis' . $jj]])?'undefined':"'" .  str_replace("'", "\'", $result[$_REQUEST['zzaxis' . $jj]]) . "'") . ");";
              $jjj++;
            }
          }
          $j++;
        }
        $strdata .= "var chart = new google.visualization." . $type . "(document.getElementById('chart_div'));chart.draw(data, {" . $settings . ",displayAnnotations:TRUE,displayAnnotationsFilter:TRUE});";
      }
      else {
        $strdata="var data = new google.visualization.DataTable();
            var data = new google.visualization.DataTable();
            data.addColumn('date', 'Date');
            data.addColumn('number', 'Sold Pencils');
            data.addColumn('string', 'title1');
            data.addColumn('string', 'text1');
            data.addColumn('number', 'Sold Pens');
            data.addColumn('string', 'title2');
            data.addColumn('string', 'text2');
            data.addRows([
            [new Date(2008, 1 ,1), 30000, undefined, undefined, 40645, undefined, undefined],
            [new Date(2008, 1 ,2), 14045, undefined, undefined, 20374, undefined, undefined],
            [new Date(2008, 1 ,3), 55022, undefined, undefined, 50766, undefined, undefined],
            [new Date(2008, 1 ,4), 75284, undefined, undefined, 14334, 'Out of Stock', 'Ran out of stock on pens at 4pm'],
            [new Date(2008, 1 ,5), 41476, 'Bought Pens', 'Bought 200k pens', 66467, undefined, undefined],
            [new Date(2008, 1 ,6), 33322, undefined, undefined, 39463, undefined, undefined]
            ]);
            var chart = new google.visualization.AnnotatedTimeLine(document.getElementById('chart_div'));
            chart.draw(data, {" . $settings . "});";
      }
      break;
    case 11:
      $type="Map";
      $geomaplat1=$_REQUEST['geomaplat1'];
      $geomaplon1=$_REQUEST['geomaplon1'];
      $geomapstring=$_REQUEST['geomapstring'];
      $strdata="";
      if ($geomaplat1!='NULL' && $geomaplon1!='NULL') {
        $strdata = "var data = new google.visualization.DataTable();";
        $strdata .= "data.addColumn('number', '" . $geomaplat1. "');";
        $strdata .= "data.addColumn('number', '" . $geomaplon1. "');";
        if ($geomapstring!='NULL') {
          $strdata .= "data.addColumn('string', '" . $geomapstring . "');";
        }
        $strdata .= "data.addRows(" . $no_of_rows . ");";
        $j=0;
        while ($result = db_fetch_array($results)) {
          $strdata .= "data.setValue(" . $j . ", 0," . (is_null($value)?'undefined':$result[$geomaplat1]) . ");";
          $strdata .= "data.setValue(" . $j . ",1," . (is_null($value)?'undefined':$result[$geomaplon1]) . ");";
          if ($geomapstring!='NULL') {
            $strdata .= "data.setValue(" . $j . ",2," . (is_null($value)?'undefined':"'" . str_replace("'", "\'", $result[$geomapstring]) . "'") . ");";
          }
          $j++;
        }
        $strdata .= "var chart = new google.visualization." . $type . "(document.getElementById('chart_div'));chart.draw(data, {" . $settings . "});";
      }
      break;
  };

  if ($_REQUEST['clickedembed']) {
    $basename = $tablename .'.html';
    $dest_path = file_directory_path() . '/gvs_embed/' . $user->uid;
    file_check_directory($dest_path, TRUE);
    $formaps="";
    $api_key = variable_get('dv_api_key', False);
    if ($api_key && $type1==7) {
      $gvs_gmap_gapi="http://maps.google.com/maps?file=api&v=2&key=" . $api_key;
      $formaps='<script type="text/javascript" src="'. $gvs_gmap_gapi  . '"></script>';
    }

    $wholehtml='<html><head><script type="text/javascript" src="http://www.google.com/jsapi"></script>' . $formaps . '<script type="text/javascript">google.load("visualization", "1", {packages:["annotatedtimeline", "areachart", "barchart", "piechart", "columnchart", "linechart", "scatterchart", "imageareachart", "gauge", "motionchart", "geomap", "intensitymap", "map"]});function drawChart() {' . $strdata . '}google.setOnLoadCallback(drawChart);</script></head><body><div id="chart_div" style="height:400px;width:600px;"></div></body></html>';
    if ($_GET['update']) {
      if ($_GET['filename']!="NULL") {
        $dest=file_directory_path() . '/gvs_embed/' . $user->uid . '/' . $_GET['filename'];
      }
      else {
        $dest=file_directory_path() . '/gvs_embed/' . $user->uid . '/' . $tablename .'.html';
      }
      $filename = file_save_data($wholehtml, $dest, $replace = FILE_EXISTS_REPLACE);
    }
    else {
      $dest=file_directory_path() . '/gvs_embed/' . $user->uid . '/' . $tablename .'.html';
      $filename = file_save_data($wholehtml, $dest, $replace = FILE_EXISTS_RENAME);
    }

    $vidi_link=$base_url . '/vidi/gvs_form/'. $tablename;
    $iframe='<iframe width="600px" height="400px" scrolling = "no" source="' . $base_url . '/' . $dest . '"></iframe>';
    $filename1 = substr($filename, strrpos($filename, '/')+1, strlen($filename)-strrpos($filename, '/'));
    _gvs_save_file_data($user->uid, $filename1, $filename, serialize($_REQUEST), $vidi_link, '', $iframe, $_REQUEST['update'], $_REQUEST['title'], $type1);
    print '<div class="embed-code" style="color: #666; font-size:90%; float:right;"><strong>Embed link:</strong><br/>&lt;iframe width="600px" height="400px" scrolling = "no" source="' . $base_url . '/' . $filename . '"&gt;&lt;/iframe&gt</div>';
  }
  else
    print "<script type='text/javascript'> function drawChart() {" . $strdata . "}</script>";
}